#zip.py: zlib compression/decompression demonstration
# Gergely Biczok, CrySyS Lab, 2020

import zlib
import sys, getopt, re

operation = ''
level = ''
ifile_name = ''
ofile_name = ''


try:
    opts, args = getopt.getopt(sys.argv[1:], 'hc:di:o:')
except getopt.GetoptError as e:
    print('Usage: zip.py [-c <level>|-d] -i <inputfile> -o <outputfile>')
    print(repr(e))
    sys.exit(1)

for opt, arg in opts:
    if opt == '-h':
        print('Usage: zip.py [-c <level>|-d] -i <inputfile> -o <outputfile>')
        sys.exit(0)
    elif opt == '-c':
        operation = 'compression'
        level = arg
    elif opt == '-d':
        operation = 'decompression'
        wbits = arg
    elif opt == '-i':
        ifile_name = arg
    elif opt == '-o':
        ofile_name = arg

if (operation != 'compression') and (operation != 'decompression'):
    print('Error: Operation must be -c (for compression) or -d (for decompression).')
    sys.exit(1)

if not ifile_name:
    print('Error: Name of input file is missing.')
    sys.exit(1)

if not ofile_name:
    print('Error: Name of output file is missing.')
    sys.exit(1)

if not level:
    print('Compression level is missing, going with default.')
    level = -1

# compression
if operation == 'compression':
    print('Compressing...', end='')

# read the content of the input file into a variable called original_data
    #with open(ifile_name, 'rb') as ___:
        #original_data = ___.read()

    # main compression part
    # use the compression level from the argument, it should be an integer!
    #compressed_data = zlib.___(original_data, ___)

    # calculate compression ratio
    # and print it in percentage
    #compress_ratio = (float(len(original_data)) - float(len(compressed_data))) / float(___)
    #print('Compressed: %f %%' % (100.0 * ___))

    # write out the encoded text to the output file
    #with open(ofile_name, "wb") as f:
    #    f.write(___)

# decompression
if operation == 'decompression':
    print('Decompressing...', end='')

    # read the content of the compressed input file into a variable called input_string
    #with open(ifile_name, 'rb') as f:
        #___ = f.read()

    # main decompression part
    #___ = zlib.___(compressed_data)

    # write out the decoded text to the output file
    #with open(ofile_name, "wb") as f:
        #f.write(___)
